summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorYevhenii Shapovalov <yshapova@redhat.com>2017-12-08 18:10:56 +0200
committerYevhenii Shapovalov <yshapova@redhat.com>2017-12-08 18:10:56 +0200
commit75c00db4701744929ed8e795e47a381a3762f768 (patch)
tree5685cc2e27bf447ca4d77edd545bd25797a9041b
parentba7b000a4cc534dd498a64a8b11ddde3a65d3bdc (diff)
downloadgroff-75c00db4701744929ed8e795e47a381a3762f768.tar.gz
groff-75c00db4701744929ed8e795e47a381a3762f768.tar.xz
groff-75c00db4701744929ed8e795e47a381a3762f768.zip
add_testsHEADadd_tests
-rw-r--r--tests/README.md3
m---------tests/tests0
-rw-r--r--tests/tests.yml15
-rw-r--r--tests/unicode-segfault/Makefile64
-rw-r--r--tests/unicode-segfault/PURPOSE6
-rw-r--r--tests/unicode-segfault/ls.1.gzbin0 -> 4110 bytes
-rwxr-xr-xtests/unicode-segfault/runtest.sh53
7 files changed, 141 insertions, 0 deletions
diff --git a/tests/README.md b/tests/README.md
new file mode 100644
index 0000000..3c78749
--- /dev/null
+++ b/tests/README.md
@@ -0,0 +1,3 @@
+# groff
+
+groff tests \ No newline at end of file
diff --git a/tests/tests b/tests/tests
new file mode 160000
+Subproject 039213c51ff0e36f160f8a2161b9968f5673690
diff --git a/tests/tests.yml b/tests/tests.yml
new file mode 100644
index 0000000..102094a
--- /dev/null
+++ b/tests/tests.yml
@@ -0,0 +1,15 @@
+---
+# Tests that run in all contexts
+- hosts: localhost
+ vars:
+ use_beakerlib_libraries: false
+ roles:
+ - role: standard-test-rhts
+ tags:
+ - classic
+ - container
+ tests:
+ - unicode-segfault
+ required_packages:
+ - findutils # beakerlib needs find command
+ - gzip # required by unicode-segafault test
diff --git a/tests/unicode-segfault/Makefile b/tests/unicode-segfault/Makefile
new file mode 100644
index 0000000..f82baf1
--- /dev/null
+++ b/tests/unicode-segfault/Makefile
@@ -0,0 +1,64 @@
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+# Makefile of /CoreOS/groff/Regression/bz176904-unicode-segfault
+# Description: Test whether groff can display Unicode characters correctly.
+# Author: Jakub Heger <jheger@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+# Copyright (c) 2017 Red Hat, Inc.
+#
+# This program is free software: you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation, either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be
+# useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+# PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see http://www.gnu.org/licenses/.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+export TEST=/CoreOS/groff/unicode-segfault
+export TESTVERSION=1.0
+
+BUILT_FILES=
+
+FILES=$(METADATA) runtest.sh Makefile PURPOSE ls.1.gz
+
+.PHONY: all install download clean
+
+run: $(FILES) build
+ ./runtest.sh
+
+build: $(BUILT_FILES)
+ test -x runtest.sh || chmod a+x runtest.sh
+
+clean:
+ rm -f *~ $(BUILT_FILES)
+
+
+include /usr/share/rhts/lib/rhts-make.include
+
+$(METADATA): Makefile
+ @echo "Owner: Jakub Heger <jheger@redhat.com>" > $(METADATA)
+ @echo "Name: $(TEST)" >> $(METADATA)
+ @echo "TestVersion: $(TESTVERSION)" >> $(METADATA)
+ @echo "Path: $(TEST_DIR)" >> $(METADATA)
+ @echo "Description: Test whether groff can display Unicode characters correctly." >> $(METADATA)
+ @echo "Type: Regression" >> $(METADATA)
+ @echo "TestTime: 5m" >> $(METADATA)
+ @echo "RunFor: groff" >> $(METADATA)
+ @echo "Requires: groff gzip" >> $(METADATA)
+ @echo "Priority: Normal" >> $(METADATA)
+ @echo "License: GPLv2+" >> $(METADATA)
+ @echo "Confidential: no" >> $(METADATA)
+ @echo "Destructive: no" >> $(METADATA)
+ @echo "Bug: 176904" >> $(METADATA)
+ @echo "Releases: -RHEL4 -RHELClient5 -RHELServer5" >> $(METADATA)
+
+ rhts-lint $(METADATA)
diff --git a/tests/unicode-segfault/PURPOSE b/tests/unicode-segfault/PURPOSE
new file mode 100644
index 0000000..640ae95
--- /dev/null
+++ b/tests/unicode-segfault/PURPOSE
@@ -0,0 +1,6 @@
+This test whether groff can display Unicode characters correctly.
+
+It pipes the content of a Japanese manpage through troff and grotty and checks
+if grotty does segfault in the process - see RH BZ#176904
+
+It can be also used as a smoke test for groff.
diff --git a/tests/unicode-segfault/ls.1.gz b/tests/unicode-segfault/ls.1.gz
new file mode 100644
index 0000000..ac5d423
--- /dev/null
+++ b/tests/unicode-segfault/ls.1.gz
Binary files differ
diff --git a/tests/unicode-segfault/runtest.sh b/tests/unicode-segfault/runtest.sh
new file mode 100755
index 0000000..524c673
--- /dev/null
+++ b/tests/unicode-segfault/runtest.sh
@@ -0,0 +1,53 @@
+#!/bin/bash
+# vim: dict+=/usr/share/beakerlib/dictionary.vim cpt=.,w,b,u,t,i,k
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+# runtest.sh of /CoreOS/groff/Regression/bz176904-unicode-segfault
+# Description: Test whether groff can display Unicode characters correctly.
+# Author: Jakub Heger <jheger@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+# Copyright (c) 2017 Red Hat, Inc.
+#
+# This program is free software: you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation, either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be
+# useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+# PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see http://www.gnu.org/licenses/.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+# Include Beaker environment
+. /usr/bin/rhts-environment.sh || exit 1
+. /usr/share/beakerlib/beakerlib.sh || exit 1
+
+PACKAGE="groff"
+
+set -o pipefail
+
+rlJournalStart
+ rlPhaseStartSetup
+ rlAssertRpm $PACKAGE
+ rlRun "TmpDir=\$(mktemp -d)" 0 "Creating tmp directory"
+ rlRun "cp ./ls.1.gz $TmpDir" 0 "Copying man page to temp dir"
+ rlRun "pushd $TmpDir"
+ rlPhaseEnd
+
+ rlPhaseStartTest
+ rlRun "zcat ./ls.1.gz | troff -Tutf8 -man | grotty 1>/dev/null" 0
+ rlPhaseEnd
+
+ rlPhaseStartCleanup
+ rlRun "popd"
+ rlRun "rm -r $TmpDir" 0 "Removing tmp directory"
+ rlPhaseEnd
+rlJournalPrintText
+rlJournalEnd